	; IntyBASIC compiler v0.2 Feb/03/2014
        ;
        ; Prologue for IntyBASIC programs
        ; by Oscar Toledo G.  http://nanochess.org/
        ;
        ; Revision: Jan/30/2014. Spacing adjustment and more comments.

        ROMW 16
        ORG $5000
        
        ;
        ; ROM header
        ;
        BIDECLE _ZERO           ; MOB picture base
        BIDECLE _ZERO           ; Process table
        BIDECLE _MAIN           ; Program start
        BIDECLE _ZERO           ; Background base image
        BIDECLE _ONES           ; GRAM
        BIDECLE _TITLE          ; Cartridge title and date
        DECLE   $03C0           ; No ECS title, inits code after title,
                                ; ... no clicks
                                
_ZERO:  DECLE   $0000           ; Border control
        DECLE   $0000           ; 0 = color stack, 1 = f/b mode
        
_ONES:  DECLE   $0001, $0001    ; Initial color stack 0 and 1: Blue
        DECLE   $0001, $0001    ; Initial color stack 2 and 3: Blue
        DECLE   $0001           ; Initial border color: Blue

C_WHT:  EQU $0007

CLRSCR: MVII #$200,R4           ; Used also for CLS
        MVII #$F0,R1
FILLZERO:
        CLRR R0
MEMSET:
        MVO@ R0,R4
        DECR R1
        BNE MEMSET
        JR R5

        ;
        ; Title, avoid and jump directly into main program
        ;
_TITLE: PROC
        BYTE    114, 'IntyBASIC program', 0
;        BEGIN

;        RETURN                  ; Return to EXEC for title screen display
        ENDP

        ;
        ; Main program
        ;
_MAIN:
        DIS
        MVII #STACK,R6

_MAIN0:
        ;
        ; Clean memory
        ;
        MVII #$0fe,R1           ; 240 words of 8 bits plus 14 of sound
        MVII #$100,R4           ; 8-bit scratch RAM
        CALL FILLZERO
        MVII #$040,R1           ; 64 words of 16 bits
        MVII #$320,R4           ; 16-bit scratch RAM
        CALL FILLZERO

        CALL CLRSCR             ; Clean up screen

        MVII #_int_vector,R0 ; Points to interrupt vector
        MVO R0,ISRVEC
        SWAP R0
        MVO R0,ISRVEC+1
        MVII #2,R0
        MVO R0,_first_time

        EIS
        MVII #7,R0
        MVO R0,_color           ; Default color for PRINT "string"
        MVII #$038,R0
        MVO R0,$01F8            ; Configures sound
	; 	REM
	;     REM Animated title screen
	;     REM Demo for IntyBASIC
	;     REM by Oscar Toledo G.  http://nanochess.org/
	;     REM Jan/30/2014
	;     REM
	;     WAIT
	CALL _wait
	; 	DEFINE 0,1,bitmaps0
	MVII #0,R0
	MVO R0,_gram_target
	MVII #1,R0
	MVO R0,_gram_total
	MVII #Q1,R4
	MVO R4,_gram_bitmap
	MVII #1,R0
	MVO R0,_load_gram
	; 	WAIT
	CALL _wait
	; 	CLS
	CALL CLRSCR
	MVII #$200,R0
	MVO R0,_screen
	; 	PRINT COLOR 6
	MVII #6,R0
	MVO R0,_color
	; 	PRINT AT   4,"\256\256\000\000\256\256\256\000\256\256\256"
	MVII #516,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT  24,"\256\000\256\000\000\256\000\000\256\000\000"
	MVII #536,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT  44,"\256\256\000\000\000\256\000\000\256\000\256"
	MVII #556,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT  64,"\256\000\256\000\000\256\000\000\256\000\256"
	MVII #576,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT  84,"\256\256\000\000\256\256\256\000\256\256\256"
	MVII #596,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	
	; 	PRINT AT 122,"\256\256\256\000\256\256\256\000\256\000\256\000\256\256\256"
	MVII #634,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT 142,"\256\000\000\000\256\000\256\000\256\256\256\000\256\000\000"
	MVII #654,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT 162,"\256\000\256\000\256\256\256\000\256\256\256\000\256\256\000"
	MVII #674,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT 182,"\256\000\256\000\256\000\256\000\256\000\256\000\256\000\000"
	MVII #694,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVO R4,_screen
	; 	PRINT AT 202,"\256\256\256\000\256\000\256\000\256\000\256\000\256\256\256"
	MVII #714,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #2048,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; loop:
	; LOOP
Q2:	;     WAIT
	CALL _wait
	; 	WAIT
	CALL _wait
	; 	DEFINE 0,1,bitmaps1
	MVII #0,R0
	MVO R0,_gram_target
	MVII #1,R0
	MVO R0,_gram_total
	MVII #Q3,R4
	MVO R4,_gram_bitmap
	MVII #1,R0
	MVO R0,_load_gram
	; 	WAIT
	CALL _wait
	; 	WAIT
	CALL _wait
	; 	DEFINE 0,1,bitmaps2
	MVII #0,R0
	MVO R0,_gram_target
	MVII #1,R0
	MVO R0,_gram_total
	MVII #Q4,R4
	MVO R4,_gram_bitmap
	MVII #1,R0
	MVO R0,_load_gram
	; 	WAIT
	CALL _wait
	; 	WAIT
	CALL _wait
	; 	DEFINE 0,1,bitmaps3
	MVII #0,R0
	MVO R0,_gram_target
	MVII #1,R0
	MVO R0,_gram_total
	MVII #Q5,R4
	MVO R4,_gram_bitmap
	MVII #1,R0
	MVO R0,_load_gram
	; 	WAIT
	CALL _wait
	; 	WAIT
	CALL _wait
	; 	DEFINE 0,1,bitmaps0
	MVII #0,R0
	MVO R0,_gram_target
	MVII #1,R0
	MVO R0,_gram_total
	MVII #Q1,R4
	MVO R4,_gram_bitmap
	MVII #1,R0
	MVO R0,_load_gram
	; 	GOTO loop
	B Q2
	; 
	; bitmaps0:
	; BITMAPS0
Q1:	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "XXXXXXX_"
	DECLE 65278
	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "________"
	DECLE 254
	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "XXX_XXXX"
	DECLE 61423
	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "________"
	DECLE 239
	; 
	; bitmaps1:
	; BITMAPS1
Q3:	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "________"
	DECLE 254
	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "XXX_XXXX"
	DECLE 61423
	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "________"
	DECLE 239
	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "XXXXXXX_"
	DECLE 65278
	; 
	; bitmaps2:
	; BITMAPS2
Q4:	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "XXX_XXXX"
	DECLE 61423
	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "________"
	DECLE 239
	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "XXXXXXX_"
	DECLE 65278
	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "________"
	DECLE 254
	; 
	; bitmaps3:
	; BITMAPS3
Q5:	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "________"
	DECLE 239
	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "XXXXXXX_"
	DECLE 65278
	; 	BITMAP "XXXXXXX_"
	; 	BITMAP "________"
	DECLE 254
	; 	BITMAP "XXX_XXXX"
	; 	BITMAP "XXX_XXXX"
	DECLE 61423
	; 
        ;
        ; Epilogue for IntyBASIC programs
        ; by Oscar Toledo G.  http://nanochess.org/
        ;
        ; Revision: Jan/30/2014. Moved GRAM code below MOB updates.
        ;                        Added comments.

        ;
        ; Wait for interruption
        ;
_wait:  PROC
        CLRR    R0
        MVO     R0,_int         ; Clears waiting flag
@@1:    CMP     _int,  R0       ; Waits for change
        BEQ     @@1
        JR      R5              ; Returns
        ENDP

        ;
        ; Interruption routine
        ;
_int_vector:     PROC
        BEGIN

        MVO     R0,     $20     ; Activates display
        MVI     $21,    R0      ; Activates mode for 64 definitions of MOB
        MVII    #1,     R0
        MVO     R0,     _int    ; Indicates interrupt happened
        MVI _first_time,R0
        TSTR R0
        BEQ @@vi0
        DECR R0
        MVO R0,_first_time
        MVII    #0,     R0
        MVO     R0,     $28     ; Color stack 0
        MVO     R0,     $2A     ; Color stack 2
        MVO     R0,     $2C     ; Border color
@@vi0:
        ;
        ; Save collision registers for further use
        ;
        MVI     $18,R0
        MVO     R0,_col0
        MVI     $19,R0
        MVO     R0,_col1
        MVI     $1A,R0
        MVO     R0,_col2
        MVI     $1B,R0
        MVO     R0,_col3
        MVI     $1C,R0
        MVO     R0,_col4
        MVI     $1D,R0
        MVO     R0,_col5
        MVI     $1E,R0
        MVO     R0,_col6
        MVI     $1F,R0
        MVO     R0,_col7
        CLRR    R0
        MVO 	R0,$18
        MVO 	R0,$19
        CLRR    R0
        MVO     R0,$1A
        MVO     R0,$1B
        CLRR    R0
        MVO     R0,$1C
        MVO     R0,$1D
        CLRR    R0
        MVO 	R0,$1E
        MVO     R0,$1F

        ;
        ; Updates sprites (MOBs)
        ;
        MVII #_mobs,R4
        MVII #$0,R5     ; X-coordinates
        MVII #8,R1
@@vi2:  MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        DECR R1
        BNE @@vi2

        ;
        ; Detect GRAM definition
        ;
        MVI _load_gram,R0
        TSTR R0
        BEQ @@vi1
        CLRR R0
        MVO R0,_load_gram
        MVI _gram_bitmap,R4
        MVI _gram_target,R1
        SLL R1,2
        SLL R1,1
        ADDI #$3800,R1
        MOVR R1,R5
        MVI _gram_total,R0
@@vi3:
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        DECR R0
        BNE @@vi3
@@vi1:
        ;
        ; Random number generator
        ;
MACRO _ROR
	RRC R0,1
	MOVR R0,R1
	SLR R1,2
	SLR R1,2
	ANDI #$0800,R1
	SLR R1,2
	SLR R1,2
	ANDI #$007F,R0
	XORR R1,R0
ENDM
        MVI _rand,R0
        SETC
        _ROR
        XOR _frame,R0
        _ROR
        XOR _rand,R0
        _ROR
        XORI #9,R0
        MVO R0,_rand

        ; Increase frame number
        MVI _frame,R0
        INCR R0
        MVO R0,_frame

        RETURN
        ENDP
    
        ORG $330,$330,"-RWB"
        ;
        ; 16-bits variables
        ;
_frame:     RMB 1       ; Current frame
_read:      RMB 1       ; Pointer to DATA
_gram_bitmap:   RMB 1   ; Bitmap for definition
_screen:    RMB 1       ; Pointer to current screen position
_color:     RMB 1       ; Current color
_mobs:      RMB 3*8     ; MOB buffer
_col0:      RMB 1       ; Collision status for MOB0
_col1:      RMB 1       ; Collision status for MOB1
_col2:      RMB 1       ; Collision status for MOB2
_col3:      RMB 1       ; Collision status for MOB3
_col4:      RMB 1       ; Collision status for MOB4
_col5:      RMB 1       ; Collision status for MOB5
_col6:      RMB 1       ; Collision status for MOB6
_col7:      RMB 1       ; Collision status for MOB7

SCRATCH:    ORG $100,$100,"-RWBN"
        ;
        ; 8-bits variables
        ;
ISRVEC:     RMB 2       ; Pointer to ISR vector (require by Intellivision ROM)
_int:       RMB 1       ; Signals interrupt received
_rand:      RMB 1       ; Pseudo-random value
_load_gram: RMB 1       ; Signals GRAM definition waiting
_gram_target:   RMB 1   ; Contains GRAM card number
_gram_total:    RMB 1   ; Contains total GRAM cards for definition
_first_time:    RMB 1   ; Signals program started for first time
_SCRATCH:	EQU $

SYSTEM:	ORG $2F0, $2F0, "-RWBN"
STACK:	RMB 32
_SYSTEM:	EQU $
